﻿SystemOrganization addCategory: #'Neo4reSt-Core'!

Dictionary subclass: #N4Dictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

Error subclass: #N4Error
	instanceVariableNames: 'properties response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4CannotDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:02'!
properties: assocs
	^self new properties: assocs! !

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:22'!
response: response
	^self new response: response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties
	"Answer the value of properties"

	^ properties! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties: anObject
	"Set the value of properties"

	properties := anObject! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response
	"Answer the value of response"

	^ response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response: anObject
	"Set the value of response"

	response := anObject! !

N4Error subclass: #N4NoContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4NotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

Object subclass: #N4PortableUtil
	instanceVariableNames: ''
	classVariableNames: 'ActualClass'
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4PortableUtil class
	instanceVariableNames: 'default'!

N4PortableUtil class
	instanceVariableNames: 'default'!

!N4PortableUtil class methodsFor: 'private' stamp: 'mu 11/27/2011 12:39'!
activate
	ActualClass := self.
	^ActualClass! !

!N4PortableUtil class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 16:18'!
default
	default ifNil: [default := ((N4PortableUtil subclasses at: 1) activate) new].
	^ default! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initDefault
	default := nil! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initialize
	"override"! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 2/13/2012 00:51'!
asProperties: someProps

	^someProps isArray ifTrue: [someProps] ifFalse: [Array with: someProps].! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
deleteJsonFrom: urlString ! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 4/22/2012 22:33'!
dictionaryFromAssociations: assocs
	| dict |
	dict := Dictionary new: assocs size.
	dict addAll: assocs.
	^ dict! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:42'!
getJsonFrom: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/29/2011 23:03'!
getJsonOrEmptyFrom: urlString

	^[self getJsonFrom: urlString]
		on: N4NoContent
		do: [:ex | ex return: #()]! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonDelete: urlString ! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/29/2011 22:59'!
httpJsonGet: urlString
! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString
	
	! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString content: jsonString
	
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
jsonStringFrom: assocs
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/9/2011 00:35'!
pickIdFrom: uriString 
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/data/node/10'"
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/'"
	| sz |
	(sz := uriString size)
		to: 1
		by: -1
		do: [:idx | $/ = (uriString at: idx)
				ifTrue: [| chopped |
					chopped := uriString copyFrom: idx + 1 to: sz.
					^ chopped isEmpty
						ifTrue: [0]
						ifFalse: [chopped asInteger]]].
	^ -1! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:40'!
postJson: json to: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
postJsonTo: urlString
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
readJsonFrom: aStream

	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/23/2011 13:05'!
readJsonFromResponse: httpResponse! !

!N4PortableUtil methodsFor: 'error handling' stamp: 'mu 11/27/2011 22:42'!
signalErrorBasedOn: response ! !

!N4PortableUtil methodsFor: 'misc utils' stamp: 'mu 11/27/2011 23:58'!
string: aString beginsWith: prefix 
	^ (prefix, '*') match: aString! !
N4PortableUtil initialize!
